/*
 * Copyright (c) 2010 by Intevation GmbH
 *
 * This program is free software under the LGPL (>=v2.1)
 * Read the file LGPL.txt coming with the software for details
 * or visit http://www.gnu.org/licenses/ if it does not exist.
 */
package de.intevation.artifacts.httpclient.http;

import java.io.OutputStream;

import org.w3c.dom.Document;

import de.intevation.artifacts.httpclient.exceptions.ConnectionException;
import de.intevation.artifacts.httpclient.http.response.ResponseHandler;
import de.intevation.artifacts.httpclient.objects.Artifact;
import de.intevation.artifacts.httpclient.objects.ArtifactFactory;
import de.intevation.artifacts.httpclient.utils.ArtifactCreator;

/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public interface HttpClient {

    ArtifactFactory[] getArtifactFactories()
    throws ConnectionException;

    Object create(Document createDocument, ArtifactCreator creator)
    throws ConnectionException;

    Object describe(
        Artifact        artifact,
        Document        describeDocument,
        ResponseHandler handler)
    throws ConnectionException;

    Object feed(Artifact artifact, Document feedDocument, ResponseHandler handler)
    throws ConnectionException;

    Object advance(
        Artifact        artifact,
        Document        advanceDocument,
        ResponseHandler handler)
    throws ConnectionException;

    void out(
        Artifact     artifact,
        Document     outDocument,
        String       target,
        OutputStream out)
    throws ConnectionException;


    /*******************************
     * Service API
     *******************************/

     Document callService(String url, String service, Document input)
     throws ConnectionException;


    /*******************************
     * Collections API
     *******************************/

    Object createCollection(
        Document        createDocument,
        String          ownerId,
        ResponseHandler handler)
    throws ConnectionException;


    /*******************************
     * Users API
     *******************************/

    Document listUsers()
    throws ConnectionException;
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
